*~~~~~~~~~~~~ Assign Values to aggagg and AGGTOTAL0 ~~~~~~~~~~~~~~~~~~~~~~~~

* --- Assign Values to aggagg and AGGTOTAL0 ------------------------------------

$ontext

 Use eXOgenous AGGREGATE constraints if opt_AGG = 0.0.
     Control totals are accessed from Excel
       parameter AGGTOTAL0
       
 Use eNDOgenous AGGREGATE constraints if opt_AGG = 1.0.
      Control totals are calculated from P_SAM
       parameter AGGTOTAL2
 
 This process allows for the creation of selected control totals that may,
 and may not, be provided for by the standard macro-SAM, which in this programme
 is constrained to operate across contiguous accounts in the P_SAM.
     Examples include
     a.  GDP - C + I + G + X - M
     b.  Components of INDIRECT TAXES, e.g.,
         i.   Import duties
         ii.  VAT
         iii. Excise taxes
         iv.  Taxes on emissions
              etc
     c.  Components of DIRECT TAXES, e.g.,
         i.   Household income taxes
         ii.  Corporation taxes
         iii. Factor income taxes
              etc
 
 These aggregate control totals are additional to the macro SAM control totals that
 are defined in a standard macro-sam, MACROSAM0
 
 Some of these Control totals could be captured using an extended macro-SAM,
 but it is suggested that the default is to use the standard macro-SAM.
       Extending the macro-SAM requires the user to change code: the
       decisions are user and case specific
       
Selecting Aggregate Control Totals
   The selection of target aggregate totals, set aggr2(aggr) are assigned
   in the Excel worksheet 'Agg_Totals' in the column 'aggr_inc' .
   
   The selection applies to
        EITHER eXOgenous Control Totals
        OR eNDOgenous Control Totals

eXOgenous Control Totals
 The target aggregate totals in AGGTOTAL0 are defined in the Excel worksheet
 'Agg_Totals' in the column 'value_agg' with optional standard errors in
 the column 'stderr_agg'.

eNDOgenous Control Totals 
 The target aggregate totals in AGGTOTAL2 are defined by the mapping of the
 prior micro sam, P_SAM, using the parameter aggagg(sac,sacp,aggr).
 
 A range AGGREGATE controls aggregates are pre-specified in samest_aggtotal.inc
    1. The controlling set on AGGTOTAL0 is aggr, i.e., all the aggregate control
       totals that might POTENTIALLY be used in the programme.
    2. The control totals ACTUALLY imposed are a subset - aggr2(aggr).
    3. the sets aggr and aggr2(aggr) specified in the excel file, sheet "agg_totals".

$offtext



$ontext
This file defines aggregate control totals through:
(2) Other aggregate controls from the micro-sam are defined by the set
    AGGR and the aggregator set AGGagg(ac,ac,aggr). The set aggr is
    specified in the excel file and aggagg is set in samest_msam_endog.inc. The control
    totals actually used are given in the set aggr2(aggr), also defined
    in the excel file, or through aggregation of the proto-sam.

The procedure for defining the various aggregate control totals is:
(3) The other aggregate control totals are given in the set AGGR defined in
    the excel input file, and the aggregation set aggagg(ac,ac,aggr).
(4) The aggregate control totals, AGGTOTAL, are either read directly from the
    excel file (AGGTOTAL0) or computed from the proto-sam (AGGTOTAL2).
$offtext

*~~~~~ Define aggregation set aggagg for aggregates in set MACRO
$ontext
  Define aggregation set aggagg for aggregates in set aggr
  These must be defined individually.
    The list includes a lot of detailed accounts that might be
    imposed. The aggregates actually imposed are determined by the set
    aggr2(aggr) in the excel file.
$offtext

* ~~~~~ National Account Aggregates

* GDP factor cost measure as factor payments plus indirect taxes
*aggagg(f,a,"t2_gdp_fc   ")               = 1.0 ;
* GDP expenditure measure as C + G + I + X - M
aggagg(c,h,"t2_gdp_exp")                 = 1.0 ;
aggagg(c,g,"t2_gdp_exp")                 = 1.0 ;
aggagg(c,i,"t2_gdp_exp")                 = 1.0 ;
aggagg(c,w,"t2_gdp_exp")                 = 1.0 ;
aggagg(w,c,"t2_gdp_exp")                 = - 1.0 ;
* Components of GDP expenditure measure 
aggagg(c,h,"t2_p_con")                   = 1.0 ;
aggagg(c,g,"t2_g_con")                   = 1.0 ;
aggagg(c,i,"t2_i_con")                   = 1.0 ;
aggagg(c,w,"t2_x_con_fob")               = 1.0 ;
aggagg(w,c,"t2_m_con_cif")               = 1.0 ;
                                        
* ~~~~~ Tax Revenue Aggregates

aggagg(va_tax,c,"t2_vat")                = 1.0 ;
aggagg(ex_tax,c,"t2_excise")             = 1.0 ;
aggagg(m_tax,c,"t2_tariff")              = 1.0 ;
aggagg(e_tax,c,"t2_export")              = 1.0 ;
aggagg(s_tax,c,"t2_sales")               = 1.0 ;
aggagg(c_sub,c,"t2_c_sub")               = 1.0 ;
aggagg(c_tax,c,"t2_comtax")              = 1.0 ;
aggagg(i_tax,a,"t2_prod")                = 1.0 ;
aggagg(i_sub,a,"t2_a_sub")               = 1.0 ;
aggagg(a_tax,a,"t2_acttax")              = 1.0 ;
aggagg(d_tax,e,"t2_ent_dtax")            = 1.0 ;
aggagg(d_tax,h,"t2_hh_dtax")             = 1.0 ;

* ~~~~~ Factor Income Aggregates

aggagg(f,a,"t2_yf")                      = 1.0 ;
aggagg(f,w,"t2_yf")                      = 1.0 ;
aggagg(k,a,"t2_yf_cap")                  = 1.0 ;
aggagg(k,w,"t2_yf_cap")                  = 1.0 ;
aggagg(l,a,"t2_yf_lab")                  = 1.0 ;
aggagg(l,w,"t2_yf_lab")                  = 1.0 ;
aggagg(l,a,"t2_yf_employ")               = 1.0 ;
aggagg(lnd,a,"t2_yf_land ")              = 1.0 ;
aggagg(lnd,w,"t2_yf_land ")              = 1.0 ;

* ~~~~~ Institutional Income Aggregates

aggagg(h,sacn,"t2_yh")                   = 1.0 ;
aggagg(e,sacn,"t2_ye")                   = 1.0 ;
aggagg(h,f,"t2_yh_fact")                 = 1.0 ;
aggagg(e,f,"t2_ye_fact")                 = 1.0 ;

* ~~~~~ Inter Insitutional Aggregates

aggagg(h,hp,"t2_hoho")                   = 1.0 ;
aggagg(h,g,"t2_hogov")                   = 1.0 ;
aggagg(h,e,"t2_hoent")                   = 1.0 ;
aggagg(g,g,"t2_entgov")                  = 1.0 ;
aggagg(g,gp,"t2_govgov")                 = 1.0 ;

* ~~~~~ Savings Investment Aggregates

aggagg(e,i,"t2_ent_sav")                 = 1.0 ;
aggagg(h,i,"t2_hh_sav ")                 = 1.0 ;
aggagg(i,k,"t2_deprec ")                 = 1.0 ;

* ~~~~~ International Transaction Aggregates

aggagg(f,w,"t2_yf_row")                  = 1.0 ;
aggagg(k,w,"t2_yk_row")                  = 1.0 ;
aggagg(l,w,"t2_yl_row")                  = 1.0 ;
aggagg(w,f,"t2_ef_row")                  = 1.0 ;
aggagg(w,k,"t2_ek_row")                  = 1.0 ;
aggagg(w,l,"t2_el_row")                  = 1.0 ;
aggagg(f,w,"t2_net_yf_row")              = 1.0 ;
aggagg(w,f,"t2_net_yf_row")              = -1.0 ;
aggagg(k,w,"t2_net_yk_row")              = 1.0 ;
aggagg(w,k,"t2_net_yk_row")              = -1.0 ;
aggagg(l,w,"t2_net_yl_row")              = 1.0 ;
aggagg(w,l,"t2_net_yl_row")              = -1.0 ;

aggagg(h,w,"t2_yh_row")                  = 1.0 ;
aggagg(w,h,"t2_eh_row")                  = 1.0 ;
aggagg(h,w,"t2_net_yh_row")              = 1.0 ;
aggagg(w,h,"t2_net_yh_row")              = -1.0 ;

aggagg(e,w,"t2_ye_row")                  = 1.0 ;
aggagg(w,e,"t2_ee_row")                  = 1.0 ;
aggagg(e,w,"t2_net_ye_row")              = 1.0 ;
aggagg(w,e,"t2_net_ye_row")              = -1.0 ;


aggagg(g,w,"t2_yg_row")                  = 1.0 ;
aggagg(w,g,"t2_eg_row")                  = 1.0 ;
aggagg(g,w,"t2_net_yg_row")              = 1.0 ;
aggagg(w,g,"t2_net_yg_row")              = -1.0 ;


*aggagg is now complete and can be used to define aggregate control totals
*from the micro-sam, either proto-sam (SAM) or final estimated sam (SAMCE)

* --- Assign Values to AGGTOTAL -------------------------------------------

*AGGTOTAL0(aggr) is given in the excel file.
*It is set to empty in the main program if opt_agg = 1

*Compute AGGTOTAL2 from initial micro proto-sam, SAM
 AGGTOTAL2(aggr) = SUM((irow,icol), P_SAM(irow,icol)*aggagg(irow,icol,aggr)) ;
 
IF{[opt_agg = 0.0],

 AGGTOTAL(aggr2)        = AGGTOTAL0(aggr2) ;
 
  } ;
 
IF{[opt_agg = 1.0],

 AGGTOTAL(aggr2)        = AGGTOTAL2(aggr2) ;
 
  } ;

Display aggtotal0, aggtotal2, aggtotal ;


* --- END Assign Values to AGGTOTAL ---------------------------------------

*~~~~~~~~~~~ END OF Assign Values to aggagg and AGGTOTAL0 ~~~~~~~~~~~~~~~