*~~~~~~~~~~~~~~~~~ 7. DESCRIPTIVE STATISTICS ~~~~~~~~~~~~~~~~~~~~~~~~~~

* --- Descriptive Statistics for the SAM Used for Estimation ----------------

$ontext
 These descriptive statistics refer to the PRIOR SAM used
 in the estimation procedure, i.e., after all scaling and adjustments.

 These statistics are a useful summary of the prior SAM. They can
 also help if the programme is having difficulties; they provide
 information for setting the scaling and cutoff parameters.

 The same statistics are calculated and reported for the estimated SAM - SAMCE.
$offtext

 SAMNONZCNT    = SUM((sacn,sacnp)$P_SAM0(sacn,sacnp),1) ;

 SAMMEAN       = SUM((sacn,sacnp),P_SAM0(sacn,sacnp))/SAMNONZCNT ;

 SAMMAX        = SMAX((sacn,sacnp),P_SAM0(sacn,sacnp)) ;
 SAMMIN        = SMIN((sacn,sacnp),P_SAM0(sacn,sacnp)) ;

 SAMSTDEV      = SQRT(SUM((sacn,sacnp)$P_SAM0(sacn,sacnp),
                 POWER((P_SAM0(sacn,sacnp)-SAMMEAN),2))/ SAMNONZCNT) ;

 SAM1DEVLOCNT  = SUM((sacn,sacnp)$(P_SAM0(sacn,sacnp) AND P_SAM0(sacn,sacnp)
                      < (SAMMEAN - SAMSTDEV)),1) ;

 SAM1DEVHICNT  = SUM((sacn,sacnp)$(P_SAM0(sacn,sacnp) AND P_SAM0(sacn,sacnp)
                      > (SAMMEAN + SAMSTDEV)),1) ;

 SAM2DEVLOCNT  = SUM((sacn,sacnp)$(P_SAM0(sacn,sacnp) AND P_SAM0(sacn,sacnp)
                      < (SAMMEAN - (2 * SAMSTDEV))),1) ;

 SAM2DEVHICNT  = SUM((sacn,sacnp)$(P_SAM0(sacn,sacnp) AND P_SAM0(sacn,sacnp)
                      > (SAMMEAN + (2 * SAMSTDEV))),1) ;
                      

*~~~~~~~~ exporting results

* Sending the results to GDX

Execute_Unload  '3_output\%dstats%_prior-stats.gdx',
                                    SAMNONZCNT ,                                                        
                                    SAMMEAN ,      
                                    SAMMAX ,     
                                    SAMMIN ,      
                                    SAMSTDEV ,     
                                    SAM1DEVLOCNT , 
                                    SAM1DEVHICNT ,
                                    SAM2DEVLOCNT ,
                                    SAM2DEVHICNT

   ;


*~~~~~~~~~~~~~~~~~ END of DESCRIPTIVE STATISTICS ~~~~~~~~~~~~~~~~~~~~~~~~~~
